'Eigene Fonts - by Volta - 15.03.2008
Type fb_font
  As Integer breit, hoch
  As Any Ptr Start
End Type
Extern Font8  Alias "fb_font_8x8"  As fb_font
Extern Font14 Alias "fb_font_8x14" As fb_font
Extern Font16 Alias "fb_font_8x16" As fb_font

Type swbmp_Header Field = 1
  As UShort mark
  As UInteger filesize
  As UShort res1, res2
  As UInteger Offset, size, w, h
  As Short planes, bitCount
  As UInteger compression, sizeImage
  As Integer ppmX, ppmY
  As UInteger used, important,col1, col2
End Type


Function set_fbfont (ByVal x As Integer) As Integer
  Dim As Integer breit, hoch
  ScreenInfo breit, hoch
  Select Case x
    Case 8, 14, 16          'nur 8, 14 oder 16 funktioniert richtig
      Width breit\8, hoch\x ' hier wird auto. Cls ausgefhrt
    Case Else
      Return 0
  End Select
  Return 1
End Function

Function bmp_to_fbfont (ByVal filename As String, _
  ByVal hoch As Integer, _
  ByVal First As Integer) As Integer
  Dim As swbmp_Header bmh
  Dim As UByte b
  Dim As UByte Ptr dest, font
  Dim As Integer ff = FreeFile

  If Open( filename, For Binary Access Read, As #ff ) <> 0 Then
    Close #ff
    Return 0
  End If
  Get #ff, , bmh
  If (bmh.mark <> &h4d42) Or (bmh.compression <> 0) Or  _
    (bmh.planes <> 1) Or (bmh.bitCount <> 1)  Or (bmh.h <> hoch) Then
    Close #ff
    Return 0
  End If
  Select Case hoch
    Case 8
      font=Font8.Start
    Case 14
      font=Font14.Start
    Case 16
      font=Font16.Start
    Case Else
      Close #ff
      Return 0
  End Select
  set_fbfont hoch
  For y As Integer = 1 To hoch
    dest = font+((First+1)*hoch)-y
    For x As Integer = 1 To (bmh.w\8)
      Get #ff, , b
      If b>0 Then
        Asm
          mov al,Byte Ptr[b]
          Xor bl,bl
          rcl al
          rcr bl
          rcl al
          rcr bl
          rcl al
          rcr bl
          rcl al
          rcr bl
          rcl al
          rcr bl
          rcl al
          rcr bl
          rcl al
          rcr bl
          rcl al
          rcr bl
          mov Byte Ptr[b],bl
        End Asm
      End If
      *dest = b
      dest += hoch
    Next
  Next
  Close #ff
  Function = 1
End Function
